<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>

    <style>
        .dropdown {
            position: relative;
            display: inline-block;
            margin: 50px;
        }

        .dropdown ul {
            display: none;
            padding: 16px;
            margin: 0;
            position: absolute;
            top: 100%;
            left: 0;
            min-width: 100%;
            background: white;
            border-radius: 4px;
            border: 1px solid rgba(0,0,0,.5);
            box-shadow: 0 8px 8px -2px rgba(0,0,0,.3);
            list-style: none;
        }

        .dropdown li {
            margin: 8px 0;
        }

        .show {
            display: block !important;
        }
    </style>
</head>
<body style="min-height: 100vh;margin:0;">

<div id="div">
    <span>Span 1</span>
    <span id="span">Span 2</span>
    <span>Span 3</span>
</div>

<table>
    <thead>
    <tr>
        <th>Vorname</th>
        <th>Nachname</th>
        <th>Aktionen</th>
    </tr>
    </thead>
    <tbody id="tableBody">
    </tbody>
</table>

<div class="dropdown" id="dropdown-toggle">
    <button>Show Options</button>
    <ul id="dropdown-element">
        <li>
            <a href="#">Option 1</a>
        </li>
        <li>
            <a href="#">Option 2</a>
        </li>
        <li>
            <a href="#">Option 3</a>
        </li>
        <li>
            <a href="#">Option 4</a>
        </li>
    </ul>
</div>

<script>
    const dropdownElement = document.getElementById("dropdown-element");

    document.getElementById("dropdown-toggle").addEventListener("click", event => {
        event.stopPropagation()
        dropdownElement.classList.add("show")
    })

    document.addEventListener("click", () => {
        dropdownElement.classList.remove("show")
    })
</script>

<script>
document.getElementById('span').addEventListener('click', () => console.log("Span clicked"))
document.getElementById('div').addEventListener('click', event => {
    event.stopPropagation()
    console.log("Div clicked")
})
document.body.addEventListener('click', () => console.log("Body clicked"))
document.addEventListener('click', () => console.log("Document clicked"))

const tableBody = document.getElementById('tableBody')
const persons = [
    {
        firstName: 'Max',
        lastName: 'Muster'
    },
    {
        firstName: 'Maria',
        lastName: 'Muster'
    },
    {
        firstName: 'Herbert',
        lastName: 'Meier'
    }
]

function render() {
    tableBody.innerHTML = '';
    for(let i in persons) {
        tableBody.innerHTML += '<tr><td>' + persons[i].firstName + '</td><td>' + persons[i].lastName + '</td><td><button data-id="'+i+'">Löschen</button></td></tr>'
    }
}

tableBody.addEventListener('click', event => {
    if(event.target.tagName === 'BUTTON') {
        const personIndex = parseInt(event.target.dataset.id);
        persons.splice(personIndex, 1);
        render();
    }
})

render();
</script>

</body>
</html>
